;----------------------------------------------------------------------------;
; These procedures are used to fill a 3 sides  polygon with texture mapping. ; 
; This methode is not the best you could have, but it runs perfectly on my   ;
; poor 386dx33. So use it in your own piece of code.                         ;
;                                                                            ;
;                                                                    Trantor ;
;----------------------------------------------------------------------------;




;----------------------------------------------------------------------------;
; CheckCWise - Check if a side is visible or not. Check for clock wise...    ;
; INPUT : DS,SI,DX=x's BP,DS,ES=y's                                          ;
; OUTPUT: CX (>0 then visible)      DESTRUCT: Nothing                        ;
; - used by FillPoly -                                                       ;
;----------------------------------------------------------------------------;
;CheckCWise  proc near
;    cmp     di,si
;    jng     orderok1
;    mov     ax,di
;    mov     di,si
;    mov     si,dx
;    mov     dx,ax
;    mov     ax,bp
;    mov     bp,ds
;    mov     bx,es
;    mov     ds,bx
;    mov     es,ax
;orderok1:
;    cmp     di,si
;    jng     orderok2
;    mov     ax,di
;    mov     di,si
;    mov     si,dx
;    mov     dx,ax
;    mov     ax,bp
;    mov     bp,ds
;    mov     bx,es
;    mov     ds,bx
;    mov     es,ax
;orderok2:
;    mov     ax,dx
;    sub     ax,di
;    mov     bx,ds
;    sub     bx,bp
;    imul    bx
;    mov     cx,ax
;    mov     ax,si
;    sub     ax,di
;    mov     bx,es
;    sub     bx,bp
;    imul    bx
;    sub     cx,ax
;    ret
;CheckCWise  endp




;----------------------------------------------------------------------------;
; SetFTable - Sets the table used for drawing the horizontals lines.         ;
; INPUT : AX=x  CX=y                                                         ;
; OUTPUT: Nothing                   DESTRUCT: Nothing                        ;
; - used by DoLine to set table -                                            ;
;----------------------------------------------------------------------------;
SetFTableMT proc near
    cmp     cx,200
    jae     NothelastMT

    mov     bx,cx
    shl     bx,1

    cmp     ax,cs:firstbyte[bx]
    jg      NothefirstMT
    mov     cs:firstbyte[bx],ax
    mov     cs:xfirst[bx],di
    mov     cs:yfirst[bx],si
NothefirstMT:
    cmp     ax,cs:lastbyte[bx]
    jng     NothelastMT
    mov     cs:lastbyte[bx],ax
    mov     cs:xlast[bx],di
    mov     cs:ylast[bx],si
NothelastMT:
    ret
SetFTableMT endp




;----------------------------------------------------------------------------;
; DoLine - Proceed line to know the start and the end of each line.          ;
; INPUT : X1,Y1,X2,Y2...                                                     ;
; OUTPUT: Nothing                   DESTRUCT: AX CX Deltax                   ;
; - used by FillPoly - uses SetFTable -                                      ;
;----------------------------------------------------------------------------;
DoLineMT    proc near
    mov     cx,cs:y2
    cmp     cx,cs:y1
    jg      NoSwapCoordsMT  ; Check if y2>y1 to have a positive substraction,
    xchg    cx,cs:y1        ; which is need for a correct DeltaX
    mov     cs:y2,cx
    mov     ax,cs:x2
    xchg    ax,cs:x1    
    mov     cs:x2,ax 
    xchg    di,cs:xm2
    xchg    si,cs:ym2
NoSwapCoordsMT:
    mov     cx,cs:y2
    sub     cx,cs:y1        ; CX=y2-y1
    cmp     cx,0
    je      EndDoLineMT     ; Check if CX<>0
CalcDXMT:
    mov     ax,cs:xm2
    sub     ax,di
    cwd
    shl     ax,7
    idiv    cx
    mov     cs:deltaxm,ax   ; Coef need for coords interpolation along (x1,y1) (x2,y2)
    
    mov     ax,cs:ym2
    sub     ax,si
    cwd
    shl     ax,7
    idiv    cx
    mov     cs:deltaym,ax

    mov     ax,cs:x2
    sub     ax,cs:x1
    cwd         
    shl     ax,6            ; AX=64*(x2-x1)
    idiv    cx
    mov     bp,ax           ; bp=64*(x2-x1)/(y2-y1)=DeltaX

    mov     cx,cs:y1
    mov     dx,cs:y2
    mov     ax,cs:x1
    shl     ax,6            ; ax=x1*64

    shl     di,7            ; XMapping1
    shl     si,7            ; YMapping1
DoLineLoopMT:
    push    cx
    push    di
    push    si
    push    ax
    shr     di,7
    shr     si,7
    shr     ax,6
    call    SetFTableMT
    pop     ax
    pop     si
    pop     di
    
    mov     cx,cs:deltaxm
    add     di,cx
    mov     cx,cs:deltaym
    add     si,cx
    add     ax,bp
    pop     cx
    inc     cx
    cmp     cx,dx           ; CoMPare y1 & y2
    jng     DoLineLoopMT
EndDoLineMT:
    ret
DoLineMT    endp




;----------------------------------------------------------------------------;
; FillIt - Draws the calculated table. Line per line...                      ;
; INPUT : Nothing                                                            ;
; OUTPUT: Nothing                       DESTRUCT: BP CX SI DX AX CX          ;
; - used by FillPoly -                                                       ;
;----------------------------------------------------------------------------;
FillItMT    proc near
    cld
    mov     cx,200
FillItLoopMT:
    mov     bp,cx
    mov     si,cx
    dec     si
    add     si,si

    cmp     cs:firstbyte[si],320
    jge     EndFillMT
  
    mov     dx,cs:firstbyte[si]
    mov     ax,bp
    dec     ax
    mov     bx,ax
    shl     ax,6
    shl     bx,8
    add     ax,bx
    add     ax,dx
    mov     di,ax
    mov     cx,cs:lastbyte[si]
    sub     cx,dx
    cmp     cx,0
    je      endfill2MT

    mov     ax,cs:xlast[si]
    sub     ax,cs:xfirst[si]
    cwd
    shl     ax,7
    idiv    cx
    mov     bx,ax           ; bx=DeltaXMapping
    
    mov     ax,cs:ylast[si]
    sub     ax,cs:yfirst[si]
    cwd
    shl     ax,7
    idiv    cx
    mov     dx,ax           ; dx=DeltaYMapping

    mov     ax,cs:xfirst[si]
    shl     ax,7            ; ax=XMapping*128
    push    bp
    mov     bp,cs:yfirst[si]
    shl     bp,7            ; bp=YMapping*128

    push    si
llooopMT:
    push    cx
    mov     si,bp
    shr     si,7
    mov     cx,si
    shl     si,8
    shl     cx,6
    add     si,cx
    mov     cx,ax
    shr     cx,7
    add     si,cx

    mov     cl,fs:[si]
    mov     es:[di],cl
    
    add     ax,bx
    add     bp,dx
    inc     di
    pop     cx
    dec     cx
    jnz     llooopMT
    pop     si
    pop     bp
endfill2MT:
    mov     cs:lastbyte[si],-1
    mov     cs:firstbyte[si],320
    mov     cx,bp
EndFillMT:
    dec     cx
    jnz     FillItLoopMT
    ret
FillItMT    endp




;----------------------------------------------------------------------------;
; FillPoly - Draws a 4 sides polygon                                         ;
; INPUT : xvars, yvars, ES must be initialized, FS too (gfx to map)          ;
; OUTPUT: Nothing                       DESTRUCT: BX CX AX                   ;
; - uses CheckCWise, DoLine & FillIt -                                       ;
;----------------------------------------------------------------------------;
FillPolyMT  proc near
    
    push    ds
    push    es
    mov     di,cs:xvars[0]
    mov     si,cs:xvars[2]
    mov     dx,cs:xvars[4]
    mov     bp,cs:yvars[0]
    mov     ds,cs:yvars[2]
    mov     es,cs:yvars[4]
    call    CheckCWise
    pop     es
    pop     ds
    cmp     cx,0
    jng     EndFillPolyMT

    mov     bx,0
    mov     cx,3        ; 3 sides...
FillPolyLoopMT:
    mov     ax,cs:xvars[bx]
    mov     cs:x1,ax
    mov     ax,cs:yvars[bx]
    mov     cs:y1,ax
    mov     di,cs:xmap[bx]  ; di=cs:xm1
    mov     si,cs:ymap[bx]  ; si=cs:ym1
    
    mov     ax,cs:xvars[bx+2]
    mov     cs:x2,ax
    mov     ax,cs:yvars[bx+2]
    mov     cs:y2,ax
    mov     ax,cs:xmap[bx+2]
    mov     cs:xm2,ax
    mov     ax,cs:ymap[bx+2]
    mov     cs:ym2,ax

    push    bx
    push    cx
    call    DoLineMT
    pop     cx
    pop     bx
    add     bx,2
    dec     cx
    jnz     FillPolyLoopMT
    Call    FillItMT
EndFillPolyMT:
    ret
FillPolyMT  endp




;-------------------------------------------------------------Global variables




;firstbyte   dw 200 dup (320)    ; The famous table, used to have the start and
;lastbyte    dw 200 dup (-1)     ; the end of the line to draw.
xfirst      dw 200 dup (0)
yfirst      dw 200 dup (0)
xlast       dw 200 dup (0)
ylast       dw 200 dup (0)

;deltax      dw  0               ; For DoLine...
deltaxm     dw  0
deltaym     dw  0

;x1          dw  0               ; Temporary coordinates for DoLine.
;y1          dw  0

;x2          dw  0
;y2          dw  0
xm2         dw  0
ym2         dw  0


;xvars       dw  0,0,0,0,0
;yvars       dw  0,0,0,0,0
xmap        dw  0,0,0,0,0
ymap        dw  0,0,0,0,0
